<?php

namespace App\Controller;

use App\Entity\Prestataire;
use App\Entity\Rubrique;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Sonata\MediaBundle\Provider\ImageProvider;

class MapController extends AbstractController
{
    protected $imageProvider;
    private $em;

    public function __construct(ImageProvider $imageProvider, EntityManagerInterface $em)
    {
        $this->imageProvider = $imageProvider;
        $this->em = $em;
    }

    /**
     * @Route("/map/json/prestataire", name="map_prestataire_json", defaults={"rubrique": null})
     * @Route("/map/json/prestataire/{id}", name="map_prestataire_json_rubrique")
     */
    public function getJsonPrestataireMap(Rubrique $rubrique = null)
    {
        $points = [];
        $filtered_cat = null;
        if ($rubrique != null) {
            $prestataires = $this->em->getRepository(Prestataire::class)->findByRubrique($rubrique);
        } else {
            $prestataires = $this->em->getRepository(Prestataire::class)->findBy(['enabled' => true]);
        }
        dump($rubrique);
        dump($prestataires);
        foreach ($prestataires as $presta) {
            dump($presta->getGeolocs()->toArray());
            // if ($rubrique === null || $presta->getRubriques()->contains($rubrique)) {
            $geolocs = array_map(function ($geoloc) {
                if ($geoloc->isEnabled()) {
                    return $geoloc;
                }
            }, $presta->getGeolocs()->toArray());
            if (count($geolocs) > 0) {
                dump('yeah');
                $geoloc = $geolocs[0];
                // list($lat, $lon) = explode(',', $presta->latlon);
                if ($geoloc->getGeoloc()->getLon() != null and $geoloc->getGeoloc()->getLat() != null) {
                    dump('yeah2');
                    $p = new \StdClass();
                    $p->type = "Feature";
                    $p->geometry = [
                                        'type'=>'Point',
                                        'coordinates' => [$geoloc->getGeoloc()->getLon(),$geoloc->getGeoloc()->getLat()]
                                       ];
                    // $cat = [];
                    // foreach ($geo_cats as $gc) {
                    //     if ($gc['id'] == $c->cat) {
                    //         $cat = $gc;
                    //     }
                    // }
                    $p->cat = array_map(function ($rubrique) {
                        // $provider = $this->container->get($rubrique->getMedia()->getProviderName());
                        return [
                            'name' => $rubrique->getName(),
                            'icon' => (($rubrique->getMedia() != null)?$this->imageProvider->generatePublicUrl($rubrique->getMedia(), 'preview'):null),
                            'content' => $rubrique->getContent()
                        ];
                    }, $presta->getRubriques()->toArray());
                        
                    $properties = [
                                        'name' => $presta->__toString(),
                                        'popupContent'=>$presta->getMapContent(),
                                      ];
                    // if (isset($cat['id'])) {
                    //     $properties['cat'] = $cat['id'];
                    // }
                    $p->properties = $properties;
                    $points[] = $p;
                }
            }
            // }
        }
        dump($points);
        exit();
        return new JsonResponse($points);
    }
}
